/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse netlist_parse
#define yylex   netlist_lex
#define yyerror netlist_error
#define yylval  netlist_lval
#define yychar  netlist_char
#define yydebug netlist_debug
#define yynerrs netlist_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     InvalidCharacter = 258,
     Identifier = 259,
     Assign = 260,
     ScaleOrUnit = 261,
     Eol = 262,
     Eqn = 263,
     DefSub = 264,
     EndSub = 265,
     REAL = 266,
     IMAG = 267,
     COMPLEX = 268,
     Character = 269,
     STRING = 270,
     Or = 271,
     And = 272,
     Equal = 273,
     NotEqual = 274,
     GreaterOrEqual = 275,
     LessOrEqual = 276,
     Greater = 277,
     Less = 278,
     Not = 279,
     NEG = 280,
     POS = 281
   };
#endif
/* Tokens.  */
#define InvalidCharacter 258
#define Identifier 259
#define Assign 260
#define ScaleOrUnit 261
#define Eol 262
#define Eqn 263
#define DefSub 264
#define EndSub 265
#define REAL 266
#define IMAG 267
#define COMPLEX 268
#define Character 269
#define STRING 270
#define Or 271
#define And 272
#define Equal 273
#define NotEqual 274
#define GreaterOrEqual 275
#define LessOrEqual 276
#define Greater 277
#define Less 278
#define Not 279
#define NEG 280
#define POS 281




/* Copy the first part of user declarations.  */
#line 3 "parse_netlist.y"

/*
 * parse_netlist.y - parser for the Qucs netlist
 *
 * Copyright (C) 2003, 2004, 2005, 2006, 2007 Stefan Jahn <stefan@lkcc.org>
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this package; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.  
 *
 * $Id: parse_netlist.y,v 1.25 2007/04/26 16:48:25 ela Exp $
 *
 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define YYERROR_VERBOSE 42
#define YYDEBUG 1
#define YYMAXDEPTH 1000000

#include "check_netlist.h"
#include "logging.h"
#include "equation.h"
#include "range.h"



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 76 "parse_netlist.y"
{
  char * ident;
  char * str;
  double d;
  char chr;
  struct definition_t * definition;
  struct definition_t * subcircuit;
  struct node_t * node;
  struct pair_t * pair;
  struct value_t * value;
  struct {
    double r;
    double i;
  } c;
  eqn::node * eqn;
  eqn::constant * con;
  eqn::reference * ref;
  eqn::application * app;
  eqn::assignment * assign;
}
/* Line 187 of yacc.c.  */
#line 221 "parse_netlist.cpp"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 234 "parse_netlist.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  20
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   264

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  29
/* YYNRULES -- Number of rules.  */
#define YYNRULES  84
/* YYNRULES -- Number of states.  */
#define YYNSTATES  143

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   281

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    37,     2,     2,    31,     2,     2,
      41,    42,    29,    28,    43,    27,    36,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    18,    40,
       2,    16,     2,    17,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    38,     2,    39,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    19,    20,    21,    22,    23,    24,    25,    26,    32,
      33,    34
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    11,    13,    15,    17,
      19,    26,    33,    35,    37,    39,    41,    42,    45,    46,
      50,    54,    55,    58,    60,    64,    66,    69,    73,    75,
      77,    81,    82,    84,    88,    95,    96,    99,   104,   106,
     108,   110,   114,   116,   118,   120,   122,   126,   129,   132,
     134,   136,   141,   146,   150,   154,   158,   162,   166,   169,
     172,   176,   182,   186,   190,   194,   198,   202,   206,   209,
     213,   217,   218,   220,   222,   226,   230,   234,   240,   241,
     244,   247,   249,   251,   253
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      45,     0,    -1,    46,    -1,    -1,    47,    46,    -1,    68,
      -1,    59,    -1,    48,    -1,    49,    -1,     7,    -1,    36,
       4,    18,    50,    53,     7,    -1,     4,    18,    50,    52,
      53,     7,    -1,     4,    -1,     6,    -1,     4,    -1,     6,
      -1,    -1,    51,    52,    -1,    -1,     5,    55,    53,    -1,
       5,    54,    53,    -1,    -1,    37,    37,    -1,    57,    -1,
      37,    57,    37,    -1,    11,    -1,    11,     6,    -1,    11,
       6,     6,    -1,    56,    -1,    50,    -1,    38,    58,    39,
      -1,    -1,    56,    -1,    56,    40,    58,    -1,     8,    18,
      50,    61,    60,     7,    -1,    -1,    61,    60,    -1,     5,
      37,    62,    37,    -1,    63,    -1,    65,    -1,    66,    -1,
      41,    62,    42,    -1,    11,    -1,    12,    -1,    14,    -1,
      15,    -1,    62,    18,    62,    -1,    18,    62,    -1,    62,
      18,    -1,    18,    -1,     4,    -1,     4,    41,    67,    42,
      -1,    65,    38,    67,    39,    -1,    62,    28,    62,    -1,
      62,    27,    62,    -1,    62,    29,    62,    -1,    62,    30,
      62,    -1,    62,    31,    62,    -1,    28,    62,    -1,    27,
      62,    -1,    62,    35,    62,    -1,    62,    17,    62,    18,
      62,    -1,    62,    26,    62,    -1,    62,    25,    62,    -1,
      62,    23,    62,    -1,    62,    24,    62,    -1,    62,    21,
      62,    -1,    62,    22,    62,    -1,    32,    62,    -1,    62,
      20,    62,    -1,    62,    19,    62,    -1,    -1,    62,    -1,
      64,    -1,    62,    43,    67,    -1,    64,    43,    67,    -1,
      69,    70,    71,    -1,     9,    50,    52,    53,     7,    -1,
      -1,    72,    70,    -1,    10,     7,    -1,    49,    -1,    59,
      -1,    68,    -1,     7,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   118,   118,   123,   124,   135,   138,   139,   140,   141,
     147,   158,   170,   171,   175,   176,   179,   180,   187,   188,
     194,   207,   208,   212,   215,   221,   225,   230,   239,   242,
     246,   251,   252,   256,   263,   277,   278,   285,   293,   296,
     299,   302,   308,   312,   316,   320,   327,   334,   343,   352,
     366,   373,   379,   386,   393,   400,   407,   414,   421,   427,
     433,   440,   448,   455,   462,   469,   476,   483,   490,   496,
     503,   512,   513,   516,   519,   523,   530,   538,   550,   551,
     563,   567,   571,   575,   576
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "InvalidCharacter", "Identifier",
  "Assign", "ScaleOrUnit", "Eol", "Eqn", "DefSub", "EndSub", "REAL",
  "IMAG", "COMPLEX", "Character", "STRING", "'='", "'?'", "':'", "Or",
  "And", "Equal", "NotEqual", "GreaterOrEqual", "LessOrEqual", "Greater",
  "Less", "'-'", "'+'", "'*'", "'/'", "'%'", "Not", "NEG", "POS", "'^'",
  "'.'", "'\"'", "'['", "']'", "';'", "'('", "')'", "','", "$accept",
  "Input", "InputList", "InputLine", "ActionLine", "DefinitionLine",
  "InstanceIdentifier", "NodeIdentifier", "NodeList", "PairList",
  "NoneValue", "Value", "PropertyReal", "PropertyValue", "ValueList",
  "EquationLine", "EquationList", "Equation", "Expression", "Constant",
  "Range", "Reference", "Application", "ExpressionList", "SubcircuitBody",
  "DefBegin", "DefBody", "DefEnd", "DefBodyLine", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    61,    63,    58,   271,
     272,   273,   274,   275,   276,   277,   278,    45,    43,    42,
      47,    37,   279,   280,   281,    94,    46,    34,    91,    93,
      59,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    44,    45,    46,    46,    47,    47,    47,    47,    47,
      48,    49,    50,    50,    51,    51,    52,    52,    53,    53,
      53,    54,    54,    55,    55,    56,    56,    56,    57,    57,
      57,    58,    58,    58,    59,    60,    60,    61,    62,    62,
      62,    62,    63,    63,    63,    63,    64,    64,    64,    64,
      65,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    67,    67,    67,    67,    67,    68,    69,    70,    70,
      71,    72,    72,    72,    72
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       6,     6,     1,     1,     1,     1,     0,     2,     0,     3,
       3,     0,     2,     1,     3,     1,     2,     3,     1,     1,
       3,     0,     1,     3,     6,     0,     2,     4,     1,     1,
       1,     3,     1,     1,     1,     1,     3,     2,     2,     1,
       1,     4,     4,     3,     3,     3,     3,     3,     2,     2,
       3,     5,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     0,     1,     1,     3,     3,     3,     5,     0,     2,
       2,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     9,     0,     0,     0,     0,     2,     3,     7,
       8,     6,     5,    78,     0,     0,    12,    13,    16,     0,
       1,     4,    84,    81,    82,    83,     0,    78,    16,     0,
      14,    15,    16,    18,     0,     0,    76,    79,    18,     0,
      35,    17,    21,     0,    18,    80,     0,     0,     0,    35,
      25,     0,    31,    29,    18,    18,    28,    23,    77,     0,
      11,    50,    42,    43,    44,    45,     0,     0,     0,     0,
       0,    38,    39,    40,    34,    36,    26,    22,     0,    32,
       0,    20,    19,    10,    71,    59,    58,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    37,    71,    27,    24,    31,    30,
      49,    72,    73,     0,    41,     0,    70,    69,    66,    67,
      64,    65,    63,    62,    54,    53,    55,    56,    57,    60,
       0,    33,    47,    48,    71,    71,    51,     0,    52,    46,
      74,    75,    61
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     6,     7,     8,     9,    10,    53,    32,    33,    43,
      54,    55,    56,    57,    80,    11,    48,    49,   111,    71,
     112,    72,    73,   113,    12,    13,    26,    36,    27
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -103
static const yytype_int16 yypact[] =
{
      64,   -13,  -103,   -11,   112,    11,    18,  -103,    64,  -103,
    -103,  -103,  -103,   113,   112,   112,  -103,  -103,   119,   -10,
    -103,  -103,  -103,  -103,  -103,  -103,    13,   113,   119,    19,
    -103,  -103,   119,    30,   112,    34,  -103,  -103,    30,    21,
      19,  -103,     0,    58,    30,  -103,    77,    55,    81,    19,
      83,    23,    87,  -103,    30,    30,  -103,  -103,  -103,    88,
    -103,   100,  -103,  -103,  -103,  -103,    55,    55,    55,    55,
     133,  -103,    61,  -103,  -103,  -103,   118,  -103,   105,   103,
     106,  -103,  -103,  -103,    -2,   111,   111,   111,   109,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,  -103,    -2,  -103,  -103,    87,  -103,
      55,    84,   104,   107,  -103,   154,   201,   216,   229,   229,
      50,    50,    50,    50,    62,    62,   111,   111,   111,   111,
     126,  -103,   171,    55,    -2,    -2,  -103,    55,  -103,   171,
    -103,  -103,   171
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -103,  -103,   140,  -103,  -103,     1,    60,  -103,     8,   165,
    -103,  -103,   -51,   115,    59,     4,   120,   157,   -47,  -103,
    -103,  -103,  -103,  -102,    49,  -103,   160,  -103,  -103
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      70,    79,    61,   130,    16,    14,    17,    15,    34,    62,
      63,    50,    64,    65,    23,    19,   110,    24,    20,    85,
      86,    87,    88,    35,    39,    66,    67,    16,    23,    17,
      68,    24,   140,   141,    50,    42,    38,    51,    52,    69,
      41,    45,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,    79,    47,    61,
      77,    52,    25,   132,    18,    58,    62,    63,     1,    64,
      65,     2,     3,     4,    28,    29,    25,    98,    99,   100,
     101,   102,    66,    67,    60,   103,   139,    68,    74,    76,
     142,   100,   101,   102,    44,    83,    69,   103,    50,   105,
       5,    89,   133,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    16,     1,    17,   103,
      22,     3,     4,    30,   106,    31,    89,   134,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    84,   107,   108,   103,   109,   103,   135,    21,   136,
      89,   114,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   138,    78,   131,   103,    75,
     104,    89,   137,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    40,    37,    89,   103,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    46,     0,     0,   103,     0,     0,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
      82,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,     0,     0,   103,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,     0,     0,
       0,   103,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,     0,     0,   103
};

static const yytype_int16 yycheck[] =
{
      47,    52,     4,   105,     4,    18,     6,    18,    18,    11,
      12,    11,    14,    15,    13,     4,    18,    13,     0,    66,
      67,    68,    69,    10,     5,    27,    28,     4,    27,     6,
      32,    27,   134,   135,    11,     5,    28,    37,    38,    41,
      32,     7,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   108,    37,     4,
      37,    38,    13,   110,     4,     7,    11,    12,     4,    14,
      15,     7,     8,     9,    14,    15,    27,    27,    28,    29,
      30,    31,    27,    28,     7,    35,   133,    32,     7,     6,
     137,    29,    30,    31,    34,     7,    41,    35,    11,    38,
      36,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,     4,     4,     6,    35,
       7,     8,     9,     4,     6,     6,    17,    43,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    41,    37,    40,    35,    39,    35,    43,     8,    42,
      17,    42,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    39,    51,   108,    35,    49,
      37,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    29,    27,    17,    35,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    38,    -1,    -1,    35,    -1,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    35,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    35,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     4,     7,     8,     9,    36,    45,    46,    47,    48,
      49,    59,    68,    69,    18,    18,     4,     6,    50,     4,
       0,    46,     7,    49,    59,    68,    70,    72,    50,    50,
       4,     6,    51,    52,    18,    10,    71,    70,    52,     5,
      61,    52,     5,    53,    50,     7,    53,    37,    60,    61,
      11,    37,    38,    50,    54,    55,    56,    57,     7,    53,
       7,     4,    11,    12,    14,    15,    27,    28,    32,    41,
      62,    63,    65,    66,     7,    60,     6,    37,    57,    56,
      58,    53,    53,     7,    41,    62,    62,    62,    62,    17,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    35,    37,    38,     6,    37,    40,    39,
      18,    62,    64,    67,    42,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      67,    58,    62,    18,    43,    43,    42,    18,    39,    62,
      67,    67,    62
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 118 "parse_netlist.y"
    {
    definition_root = (yyvsp[(1) - (1)].definition);
  }
    break;

  case 3:
#line 123 "parse_netlist.y"
    { (yyval.definition) = NULL; }
    break;

  case 4:
#line 124 "parse_netlist.y"
    {
    if ((yyvsp[(1) - (2)].definition)) {
      (yyvsp[(1) - (2)].definition)->next = (yyvsp[(2) - (2)].definition);
      (yyval.definition) = (yyvsp[(1) - (2)].definition);
    } else {
      (yyval.definition) = (yyvsp[(2) - (2)].definition);
    }
  }
    break;

  case 5:
#line 135 "parse_netlist.y"
    {
    (yyval.definition) = (yyvsp[(1) - (1)].subcircuit);
  }
    break;

  case 9:
#line 141 "parse_netlist.y"
    {
    (yyval.definition) = NULL;
  }
    break;

  case 10:
#line 147 "parse_netlist.y"
    { 
    (yyval.definition) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.definition)->action = PROP_ACTION;
    (yyval.definition)->type = (yyvsp[(2) - (6)].ident);
    (yyval.definition)->instance = (yyvsp[(4) - (6)].ident);
    (yyval.definition)->pairs = (yyvsp[(5) - (6)].pair);
    (yyval.definition)->line = netlist_lineno;
  }
    break;

  case 11:
#line 158 "parse_netlist.y"
    { 
    (yyval.definition) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.definition)->action = PROP_COMPONENT;
    (yyval.definition)->type = (yyvsp[(1) - (6)].ident);
    (yyval.definition)->instance = (yyvsp[(3) - (6)].ident);
    (yyval.definition)->nodes = (yyvsp[(4) - (6)].node);
    (yyval.definition)->pairs = (yyvsp[(5) - (6)].pair);
    (yyval.definition)->line = netlist_lineno;
  }
    break;

  case 12:
#line 170 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[(1) - (1)].ident); }
    break;

  case 13:
#line 171 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[(1) - (1)].str); }
    break;

  case 14:
#line 175 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[(1) - (1)].ident); }
    break;

  case 15:
#line 176 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[(1) - (1)].str); }
    break;

  case 16:
#line 179 "parse_netlist.y"
    { (yyval.node) = NULL; }
    break;

  case 17:
#line 180 "parse_netlist.y"
    {
    (yyval.node) = (struct node_t *) calloc (sizeof (struct node_t), 1);
    (yyval.node)->node = (yyvsp[(1) - (2)].ident);
    (yyval.node)->next = (yyvsp[(2) - (2)].node);
  }
    break;

  case 18:
#line 187 "parse_netlist.y"
    { (yyval.pair) = NULL; }
    break;

  case 19:
#line 188 "parse_netlist.y"
    {
    (yyval.pair) = (struct pair_t *) calloc (sizeof (struct pair_t), 1);
    (yyval.pair)->key = (yyvsp[(1) - (3)].ident);
    (yyval.pair)->value = (yyvsp[(2) - (3)].value);
    (yyval.pair)->next = (yyvsp[(3) - (3)].pair);
  }
    break;

  case 20:
#line 194 "parse_netlist.y"
    {
    if (0) {
      (yyval.pair) = (struct pair_t *) calloc (sizeof (struct pair_t), 1);
      (yyval.pair)->key = (yyvsp[(1) - (3)].ident);
      (yyval.pair)->value = NULL;
      (yyval.pair)->next = (yyvsp[(3) - (3)].pair);
    } else {
      free ((yyvsp[(1) - (3)].ident));
      (yyval.pair) = (yyvsp[(3) - (3)].pair);
    }
  }
    break;

  case 21:
#line 207 "parse_netlist.y"
    { /* nothing */ }
    break;

  case 22:
#line 208 "parse_netlist.y"
    { /* also nothing */ }
    break;

  case 23:
#line 212 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[(1) - (1)].value);
  }
    break;

  case 24:
#line 215 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[(2) - (3)].value);
  }
    break;

  case 25:
#line 221 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[(1) - (1)].d);
  }
    break;

  case 26:
#line 225 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[(1) - (2)].d);
    (yyval.value)->scale = (yyvsp[(2) - (2)].str);
  }
    break;

  case 27:
#line 230 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[(1) - (3)].d);
    (yyval.value)->scale = (yyvsp[(2) - (3)].str);
    (yyval.value)->unit = (yyvsp[(3) - (3)].str);
  }
    break;

  case 28:
#line 239 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[(1) - (1)].value);
  }
    break;

  case 29:
#line 242 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->ident = (yyvsp[(1) - (1)].ident);
  }
    break;

  case 30:
#line 246 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[(2) - (3)].value);
  }
    break;

  case 31:
#line 251 "parse_netlist.y"
    { (yyval.value) = NULL; }
    break;

  case 32:
#line 252 "parse_netlist.y"
    {
    (yyvsp[(1) - (1)].value)->next = NULL;
    (yyval.value) = (yyvsp[(1) - (1)].value);
  }
    break;

  case 33:
#line 256 "parse_netlist.y"
    {
    (yyvsp[(1) - (3)].value)->next = (yyvsp[(3) - (3)].value);
    (yyval.value) = (yyvsp[(1) - (3)].value);
  }
    break;

  case 34:
#line 263 "parse_netlist.y"
    {
    /* create equation definition */
    (yyval.definition) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.definition)->type = strdup ("Eqn");
    (yyval.definition)->instance = (yyvsp[(3) - (6)].ident);
    (yyval.definition)->action = PROP_ACTION;
    (yyval.definition)->line = netlist_lineno;
    (yyvsp[(4) - (6)].assign)->setInstance ((yyvsp[(3) - (6)].ident));
    (yyvsp[(4) - (6)].assign)->setNext ((yyvsp[(5) - (6)].eqn));
    (yyvsp[(4) - (6)].assign)->applyInstance ();
    (yyval.definition)->eqns = (yyvsp[(4) - (6)].assign);
  }
    break;

  case 35:
#line 277 "parse_netlist.y"
    { (yyval.eqn) = NULL; }
    break;

  case 36:
#line 278 "parse_netlist.y"
    { 
    (yyvsp[(1) - (2)].assign)->setNext ((yyvsp[(2) - (2)].eqn));
    (yyval.eqn) = (yyvsp[(1) - (2)].assign);
  }
    break;

  case 37:
#line 285 "parse_netlist.y"
    {
    (yyval.assign) = new eqn::assignment ();
    (yyval.assign)->result = (yyvsp[(1) - (4)].ident);
    (yyval.assign)->body = (yyvsp[(3) - (4)].eqn);
  }
    break;

  case 38:
#line 293 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(1) - (1)].con);
  }
    break;

  case 39:
#line 296 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(1) - (1)].ref);
  }
    break;

  case 40:
#line 299 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(1) - (1)].app);
  }
    break;

  case 41:
#line 302 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(2) - (3)].eqn);
  }
    break;

  case 42:
#line 308 "parse_netlist.y"
    { 
    (yyval.con) = new eqn::constant (eqn::TAG_DOUBLE);
    (yyval.con)->d = (yyvsp[(1) - (1)].d);
  }
    break;

  case 43:
#line 312 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_COMPLEX);
    (yyval.con)->c = new complex (0.0, (yyvsp[(1) - (1)].d));
  }
    break;

  case 44:
#line 316 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_CHAR);
    (yyval.con)->chr = (yyvsp[(1) - (1)].chr);
  }
    break;

  case 45:
#line 320 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_STRING);
    (yyval.con)->s = (yyvsp[(1) - (1)].str);
  }
    break;

  case 46:
#line 327 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 47:
#line 334 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c = new eqn::constant (eqn::TAG_CHAR);
    c->chr = '?';
    c->append ((yyvsp[(2) - (2)].eqn));
    (yyval.app)->args = c;
  }
    break;

  case 48:
#line 343 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c = new eqn::constant (eqn::TAG_CHAR);
    c->chr = '?';
    (yyvsp[(1) - (2)].eqn)->append (c);
    (yyval.app)->args = (yyvsp[(1) - (2)].eqn);
  }
    break;

  case 49:
#line 352 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c1 = new eqn::constant (eqn::TAG_CHAR);
    eqn::constant * c2 = new eqn::constant (eqn::TAG_CHAR);
    c1->chr = '?';
    c2->chr = '?';
    c1->append (c2);
    (yyval.app)->args = c1;
  }
    break;

  case 50:
#line 366 "parse_netlist.y"
    {
    (yyval.ref) = new eqn::reference ();
    (yyval.ref)->n = (yyvsp[(1) - (1)].ident);
  }
    break;

  case 51:
#line 373 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = (yyvsp[(1) - (4)].ident);
    (yyval.app)->nargs = (yyvsp[(3) - (4)].eqn)->count ();
    (yyval.app)->args = (yyvsp[(3) - (4)].eqn);
  }
    break;

  case 52:
#line 379 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("array");
    (yyval.app)->nargs = 1 + (yyvsp[(3) - (4)].eqn)->count ();
    (yyvsp[(1) - (4)].ref)->setNext ((yyvsp[(3) - (4)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (4)].ref);
  }
    break;

  case 53:
#line 386 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("+");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 54:
#line 393 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("-");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 55:
#line 400 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("*");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 56:
#line 407 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("/");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 57:
#line 414 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("%");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 58:
#line 421 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("+");
    (yyval.app)->nargs = 1;
    (yyval.app)->args = (yyvsp[(2) - (2)].eqn);
  }
    break;

  case 59:
#line 427 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("-");
    (yyval.app)->nargs = 1;
    (yyval.app)->args = (yyvsp[(2) - (2)].eqn);
  }
    break;

  case 60:
#line 433 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("^");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 61:
#line 440 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("?:");
    (yyval.app)->nargs = 3;
    (yyvsp[(1) - (5)].eqn)->append ((yyvsp[(3) - (5)].eqn));
    (yyvsp[(1) - (5)].eqn)->append ((yyvsp[(5) - (5)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (5)].eqn);
  }
    break;

  case 62:
#line 448 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("<");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 63:
#line 455 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup (">");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 64:
#line 462 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup (">=");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 65:
#line 469 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("<=");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 66:
#line 476 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("==");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 67:
#line 483 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("!=");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 68:
#line 490 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("!");
    (yyval.app)->nargs = 1;
    (yyval.app)->args = (yyvsp[(2) - (2)].eqn);
  }
    break;

  case 69:
#line 496 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("&&");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 70:
#line 503 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("||");
    (yyval.app)->nargs = 2;
    (yyvsp[(1) - (3)].eqn)->append ((yyvsp[(3) - (3)].eqn));
    (yyval.app)->args = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 71:
#line 512 "parse_netlist.y"
    { (yyval.eqn) = NULL; }
    break;

  case 72:
#line 513 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(1) - (1)].eqn);
  }
    break;

  case 73:
#line 516 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[(1) - (1)].app);
  }
    break;

  case 74:
#line 519 "parse_netlist.y"
    {
    (yyvsp[(1) - (3)].eqn)->setNext ((yyvsp[(3) - (3)].eqn));
    (yyval.eqn) = (yyvsp[(1) - (3)].eqn);
  }
    break;

  case 75:
#line 523 "parse_netlist.y"
    {
    (yyvsp[(1) - (3)].app)->setNext ((yyvsp[(3) - (3)].eqn));
    (yyval.eqn) = (yyvsp[(1) - (3)].app);
  }
    break;

  case 76:
#line 530 "parse_netlist.y"
    { /* a full subcircuit definition found */
    (yyvsp[(1) - (3)].subcircuit)->sub = (yyvsp[(2) - (3)].definition);
    (yyval.subcircuit) = (yyvsp[(1) - (3)].subcircuit);
    (yyvsp[(2) - (3)].definition) = NULL;
  }
    break;

  case 77:
#line 538 "parse_netlist.y"
    {
    /* create subcircuit definition right here */
    (yyval.subcircuit) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.subcircuit)->type = strdup ("Def");
    (yyval.subcircuit)->instance = (yyvsp[(2) - (5)].ident);
    (yyval.subcircuit)->nodes = (yyvsp[(3) - (5)].node);
    (yyval.subcircuit)->pairs = (yyvsp[(4) - (5)].pair);
    (yyval.subcircuit)->action = PROP_ACTION;
    (yyval.subcircuit)->line = netlist_lineno;
  }
    break;

  case 78:
#line 550 "parse_netlist.y"
    { (yyval.definition) = NULL; }
    break;

  case 79:
#line 551 "parse_netlist.y"
    { /* chain definitions here */
    if ((yyvsp[(1) - (2)].definition)) {
      (yyvsp[(1) - (2)].definition)->next = (yyvsp[(2) - (2)].definition);
      (yyval.definition) = (yyvsp[(1) - (2)].definition);
    }
    else {
      (yyval.definition) = (yyvsp[(2) - (2)].definition);
    }
  }
    break;

  case 80:
#line 563 "parse_netlist.y"
    { /* nothing to do */ }
    break;

  case 81:
#line 567 "parse_netlist.y"
    { /* chain definitions here */
    (yyvsp[(1) - (1)].definition)->next = (yyval.definition);
    (yyval.definition) = (yyvsp[(1) - (1)].definition);
  }
    break;

  case 82:
#line 571 "parse_netlist.y"
    { /* chain definitions here */
    (yyvsp[(1) - (1)].definition)->next = (yyval.definition);
    (yyval.definition) = (yyvsp[(1) - (1)].definition);
  }
    break;

  case 83:
#line 575 "parse_netlist.y"
    { /* do nothing here, see subcircuit rule */ }
    break;

  case 84:
#line 576 "parse_netlist.y"
    {
    (yyval.definition) = NULL;
  }
    break;


/* Line 1267 of yacc.c.  */
#line 2290 "parse_netlist.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 582 "parse_netlist.y"


int netlist_error (char * error) {
  logprint (LOG_ERROR, "line %d: %s\n", netlist_lineno, error);
  return 0;
}

